#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: read.pleaf.m4,v 1.3 2022/12/31 18:26:38 babolo Exp $
#
#  

eval
#select  2002
SELECT 1
 FROM SQNM(x) JOIN SQNM(pass) USING(SQAT(cred))
 WHERE SQNM(pass).SQAT(flags) & CredReadPost
;
#perform 0022
UPDATE SQNM(post)
   SET SQAT(flags) = SQNM(post).SQAT(flags) & ~PostToRede
 FROM SQNM(x)
 WHERE SQNM(x).SQAT(m) == SQNM(post).SQAT(post)
   AND SQNM(x).SQAT(e) == 'r'
;
#perform 0022
UPDATE SQNM(post)
   SET SQAT(flags) = SQNM(post).SQAT(flags) | PostToRede
 FROM SQNM(x)
 WHERE SQNM(x).SQAT(m) == SQNM(post).SQAT(post)
   AND SQNM(x).SQAT(e) == 's'
;
#select  _02_
SELECT CINM(x).CIAT(sess)  AS sess, CINM(pnode).CIAT(p) AS page
 FROM CINM(pnode), CINM(x)
 WHERE CINM(pnode).CIAT(m) == 'PKG' AND CINM(pnode).CIAT(v) == 'read'
;
#select  10_2
SELECT regexp_replace( regexp_replace( regexp_replace( regexp_replace( SQNM(post).SQAT(mess)
                                                                     , '&'
                                                                     , '&amp;'
                                                                     , 'g'
                                                                     )
                                                     , '<'
                                                     , '&lt;'
                                                     , 'g'
                                                     )
                                     , '>'
                                     , '&gt;'
                                     , 'g'
                                     )
                     , '
'                    , '<br>'
                     , 'g'
                     )                                        AS mess
     , s.SQAT(srcip)                                            AS ip
     , ?1                                                         AS sess
     , ?2                                                           AS page
     , SQNM(post).SQAT(refs)                                          AS refs
     , SQNM(post).SQAT(post)                                            AS post
     , SQNM(pass).SQAT(nickname)                                          AS nickname
     , datetime(SQNM(post).SQAT(created), 'unixepoch')                      AS date
     , CASE WHEN SQNM(post).SQAT(refs) IS NOT NULL THEN ?1 END                AS sess1
     , CASE WHEN SQNM(post).SQAT(refs) IS NOT NULL THEN ?2 END                  AS page1
     , CASE WHEN SQNM(pass).SQAT(nickname) IS NULL THEN s.SQAT(login) END         AS login
     , CASE WHEN SQNM(post).SQAT(flags) & PostToRede THEN 'r' ELSE 's' END          AS change
     , CASE WHEN SQNM(post).SQAT(flags) & PostToRede THEN 'visible' ELSE 'hidden' END AS visi
 FROM  SQNM(post)
  JOIN(SELECT SQNM(sess).SQAT(sess)
            , SQNM(sess).SQAT(cred)
            , SQNM(sess).SQAT(srcip)
            , SQNM(sess).SQAT(login)
        FROM SQNM(sess)
      UNION
       SELECT SQNM(sessb).SQAT(sess)
            , SQNM(sessb).SQAT(cred)
            , SQNM(sessb).SQAT(srcip)
            , SQNM(sessb).SQAT(login)
        FROM SQNM(sessb)
      )s USING(SQAT(sess))
  JOIN SQNM(pass) USING(SQAT(cred))
    ,  SQNM(x)
 WHERE SQNM(x).SQAT(m) == SQNM(post).SQAT(post)
;
#style   00y001
read
#display 001001
#close   101001
#close   202
#close   _0_
